//
//
// O[o萔
//@VCADȒlZbgłB̏ꏊ
//
//

float2 g_TexelSize;	//x, y
float2 g_disTexelSize;
float4 Color = float4(1, 1, 1, 1);


//-----------------------------------
// eNX`
//-----------------------------------
texture InputTex;

sampler InputSmp = sampler_state
{
	Texture = <InputTex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Clamp;
	AddressV = Clamp;
};
texture DisTex;

sampler DisSmp = sampler_state
{
	Texture = <DisTex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Clamp;
	AddressV = Clamp;
};


float4 DistortionPS(float2 _UV : TEXCOORD0) : COLOR0
{
	_UV += g_disTexelSize * 0.5;
	float4 Col;
	float4 UVvec;
	UVvec = tex2D(DisSmp, _UV);
	_UV.xy += UVvec.xy - (UVvec.xy * 0.5f);
	_UV.y -= UVvec.z * 0.5f;
	_UV += g_TexelSize * 0.5;
		
	Col = tex2D(InputSmp, _UV.xy);
	return Col * Color;

}


//
//
// sNZVF[_
//
//

// sNZVF[_
//	EsNZ̐F肵A̐FԂ(R,G,B,Afloat4^)
float4 PS(float2 _UV : TEXCOORD0) : COLOR0
{
	float3 Color = 0;

	_UV += g_TexelSize*0.5;

	Color = tex2D(InputSmp, _UV);

	//㉺ẼsNZ̐F𑫂
	Color += tex2D(InputSmp, float2(_UV.x, _UV.y + g_TexelSize.y));
	Color += tex2D(InputSmp, float2(_UV.x, _UV.y - g_TexelSize.y));
	Color += tex2D(InputSmp, float2(_UV.x + g_TexelSize.x, _UV.y));
	Color += tex2D(InputSmp, float2(_UV.x - g_TexelSize.x, _UV.y));

	//F̕ςƂ
	Color /= 5;

	return float4(Color, 1);
}



// ڂsNZVF[_
float4 XBlurPS(float2 _UV : TEXCOORD0) : COLOR0
{
	float3 Color = 0;

	_UV += g_TexelSize*0.5;

	Color = tex2D(InputSmp, _UV).rgb;

	//5sNZ̐F𑫂
	for (int i = 1; i < 10; i++) {
		Color += tex2D(InputSmp, float2(_UV.x + (g_TexelSize.x*i), _UV.y));
		Color += tex2D(InputSmp, float2(_UV.x - (g_TexelSize.x*i), _UV.y));
	}

	//F̕ςƂ
	Color /= 21;

	return float4(Color, 1);
}

// cڂsNZVF[_
float4 YBlurPS(float2 _UV : TEXCOORD0) : COLOR0
{
	float3 Color = 0;

	_UV += g_TexelSize*0.5;

	Color = tex2D(InputSmp, _UV).rgb;

	//c5sNZ̐F𑫂
	for (int i = 1; i < 10; i++) {
		Color += tex2D(InputSmp, float2(_UV.x, _UV.y + (g_TexelSize.y*i)));
		Color += tex2D(InputSmp, float2(_UV.x, _UV.y - (g_TexelSize.y*i)));
	}

	//F̕ςƂ
	Color /= 21;

	return float4(Color, 1);
}





//
// eNjbN
//  `̏ڍׂ܂Ƃ߂́B
//  ܂Agp_VF[_ƃsNZVF[_w肵A
//  RenderStatew肵łB
//
//  VĆÃeNjbNgĕ`sɂȂ
//
technique Tech
{
	pass P0 {
		PixelShader = compile ps_3_0 PS();		// sNZVF[_PS()g

		ZEnable = false;						// ZEneblegpȂ
		ZWriteEnable = false;					//
	}
}

technique XBlur
{
	pass P0 {
		PixelShader = compile ps_3_0 XBlurPS();		// sNZVF[_PS()g

		ZEnable = false;						// ZEneblegpȂ
		ZWriteEnable = false;					//
	}
}

technique YBlur
{
	pass P0 {
		PixelShader = compile ps_3_0 YBlurPS();		// sNZVF[_PS()g

		ZEnable = false;						// ZEneblegpȂ
		ZWriteEnable = false;					//
	}
}

technique DisTech
{
	pass P0 {
		PixelShader = compile ps_3_0 DistortionPS();		// sNZVF[_PS()g

		ZEnable = false;						// ZEneblegpȂ
		ZWriteEnable = false;					//
	}
}

